#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif


#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "macro.h"
#include "tags.h"
#include "exglobal.h"
#include "decl.h"

# ifndef MAXMODULE
#define MAXMODULE 2000
#endif

# ifndef MAXSUB
#define MAXSUB 2000
#endif

# define MAXUNIT  (MAXMODULE>MAXSUB) ? MAXMODULE:MAXSUB

extern int debug1;
extern int intrinc_flag;

extern PTR_SYMB look_up_symb_at_scope_in_hash();
extern	int	cc_flag;

PTR_SYMB        find_arg_position();
PTR_SYMB        find_arg_keyword();

int interface_block()
{
	PTR_BFND this_bfnd;
	PTR_BLOB blob;

	this_bfnd = cur_bfnd;
	blob= this_bfnd->entry.Template.bl_ptr1;
	for ( ; blob->next ; blob=blob->next)
	{
		cur_bfnd = blob->ref;
		if (cur_bfnd->variant == MODULE_PROC_STMT)
			check_specification_stmt(cur_bfnd);
		else
			check_one_contain_procedure(blob);
	}
	cur_bfnd=blob->ref;                 /* CONTROL_END */
	
	delete_beyond_scope_level(0);
	if (debug1) show_cur_scope();
	in_interface_body -- ;
}


int strcut_decl_block()
{
	PTR_BFND this_bfnd=cur_bfnd;
	PTR_BLOB blob;

	blob = this_bfnd->entry.Template.bl_ptr1;
	for ( ; blob->next ; blob=blob->next)
	{
		cur_bfnd = blob->ref;
		check_specification_stmt(cur_bfnd);
	}
	cur_bfnd=blob->ref;                 /* CONTROL_END */
	check_specification_stmt(cur_bfnd);
}

/* added by Feng Xiaobing */
int check_block_data()
{
	PTR_SYMB symbol;

	symbol=cur_scope()->entry.block_data.blockdata_symb;
	symbol->entry.Template.common_table = CNTNULL;
}


int check_control_end()            /* by executable part */
{
	PTR_BFND    scope;
	PTR_SYMB    sym,name;
	static int  no=1;

	scope=cur_bfnd->control_parent;

	sym=scope->entry.Template.symbol;
	if (strcasecmp(sym->ident,NULL_UNIT_HEAD)==0)
		sym=SMNULL;
	
	name = cur_bfnd->entry.Template.symbol;
	if (name) {
		if (sym == SMNULL)
			error3(257,name->ident);
		else if (strcasecmp(name->ident,sym->ident))
			error3(256,sym->ident);
	}

	switch (scope->variant) {
	case MODULE_STMT: 
		in_module = 0;
                empty_access_stmt = 0;
		if (is_verbose)
			printf("** %s == End of Compilation %d at line %d ==\n",sym->ident,no++,cur_bfnd->g_line);
		break;
	case BLOCK_DATA:
		in_block_data = 0;
		if (is_verbose)
			printf("** %s (block) == End of Compilation %d at line %d ==\n",sym?sym->ident:"",no++,cur_bfnd->g_line);
		break;
	case FUNC_HEDR:
		if (is_verbose && scope->control_parent==global_bfnd)
			printf("** %s (function) == End of Compilation %d at line %d ==\n",sym->ident,no++,cur_bfnd->g_line);
		break;
	case PROC_HEDR:
		if (is_verbose && scope->control_parent==global_bfnd)
			printf("** %s (subroutine) == End of Compilation %d at line %d ==\n",sym->ident,no++,cur_bfnd->g_line);
		break;
	case PROG_HEDR:
		if (is_verbose) {
			if (strcasecmp(sym->ident,"PROG_NAME")==0)
				sym=SMNULL;
			printf("** %s (main) == End of Compilation %d at line %d ==\n",sym?sym->ident:"",no++,cur_bfnd->g_line);
		}
		break;
	default :
		printf("Abnormal!\n");
		break;
	}
/*
	if (cur_bfnd->control_parent->variant == MODULE_STMT) {
		in_module = 0;
		empty_access_stmt = 0;
	}
	if (cur_bfnd->control_parent->variant == BLOCK_DATA) {
		in_block_data = 0;
	}
*/
}

/* add by zheng.gb */
int control_end()			/* by specification part */
{

	if (in_type_define) {
		in_type_define = 0;
		type_private_flag = 0;
		type_sequence_flag = 0;
	}
}


/*  add by zheng.gb */
int program_stmt()
{
/* added by Feng Xiaobing */
	PTR_BFND 	header;
	PTR_SYMB	sym,name;

	equi_ring_number = 0;			/* added by Feng Xiaobing for EQUIVALENCE statement */
	in_subprogram = 0;
	in_interface_body = 0;

	header = cur_scope();
	header->entry.Template.symbol->entry.prog_decl.common_table = CNTNULL;
	common_sequence_flag = 0;
	name=cur_bfnd->entry.Template.symbol;
	name->decl=0;
	sym=search_symb_ref(name);
	if (sym!=name)
		error3(572,name->ident);
	name->decl=1; 
	
}

/*  add by zheng.gb */
int module_stmt()
{
/* added by Feng Xiaobing */
	PTR_BFND	header;
        PTR_SYMB        sym,name;

	equi_ring_number = 0;			/* added by Feng Xiaobing for EQUIVALENCE statement */
	header = cur_scope();
	header->entry.Template.symbol->entry.prog_decl.common_table = CNTNULL;
	common_sequence_flag = 0;
        name=cur_bfnd->entry.Template.symbol;
        /* name->decl=0; */
        sym=search_symb_ref(name);
        if (sym!=name && sym->decl==HARD)
                error3(573,name->ident);
        name->decl=HARD;
	in_module = 1; /*added by Feng Xiaobing */
	empty_access_stmt = 0;/*added by Feng Xiaobing */


}

/* return : 0: success; otherwise: ym_err code;*/
/*
int use_stmt()
{
   	PTR_BFND thisbfnd=cur_bfnd,parent=thisbfnd->control_parent;
	PTR_SYMB  module_name=thisbfnd->entry.Template.symbol;
	PTR_LLND   only_exp=thisbfnd->entry.Template.ll_ptr1;
	int errcode;

	if ((errcode=lookup_sym(module_name,global_bfnd))!=0)
		      { ym_err(thisbfnd,"no module_name");}
		else return (errcode);
	return(0);
}
*/



/* is binary intrnsic operator?     '+','-' is not included
return 0:no; 1:yes
*/
int isbinary(str)
char	*str;
{	static char  *binary[]={"**","*","/","//",".EQ.",".NE.",".LT.",".LE.",".GE.",".GT.","==","/=","<","<=",">",">="};
	int	i;

	for(i=0;i<16;i++)
		if (strcasecmp(str,binary[i])==0) return(1);
	return(0);
}


/*when interface name is an operator*/
int inter_oper(sym,interface_type,interface_arg)
PTR_SYMB	sym;
int interface_type,interface_arg;
{	PTR_SYMB	thissymb=sym->entry.Template.next;
	PTR_SYMB	dummy;
	PTR_BLOB	thisblob;
	char	*ident;

 	interface_type=FUNCTION_NAME;
	ident=sym->ident;
	
	if (strcasecmp(ident,".NOT.")==0)
		{interface_arg=1;}
		else { if (isbinary(ident)==1)
				  {	interface_arg=2;	}
				  else {interface_arg=-1;}
			}
	for (;thissymb;thissymb=thissymb->entry.Template.next)
	{
		if (thissymb->variant!=interface_type)
			{ error3(501,thissymb->ident);
		 	continue;
			}
			
		switch (thissymb->entry.Template.num_input)
		{
			 case 1: if (interface_arg==-1)
  	 			  { interface_arg=1;}
				else { if (interface_arg!=1)
						error3(502,thissymb->ident);
      				      }
				break;
   			case 2: if (interface_arg==-1)
	     				{ interface_arg=2;}
					else { if (interface_arg!=2)
						   error3(502,thissymb->ident);
						}
				break;

 		}   
		dummy=thissymb->entry.proc_decl.symb_list;
		while (dummy!=SMNULL)
   		{ if ((dummy->attr  & OPTIONAL_BIT)!=0)
			error3(503,dummy->ident );
     		   if (((dummy->attr) & (IN_BIT))==0)
			error3(504,dummy->ident);
     		   dummy=dummy->entry.var_decl.next_in;
   		}
	}
	return(0);
}


/*when generic name is assignment
return 0: success;otherwise: failure
*/
int	inter_ass(sym,interface_type,interface_arg)
 PTR_SYMB	sym;
 int interface_type,interface_arg;
 {   PTR_SYMB  thissymb=sym->entry.Template.next;
     PTR_SYMB    dummy;
	
	interface_type=PROCEDURE_NAME;
	for (;thissymb;thissymb=thissymb->entry.Template.next)
	{
		if (thissymb->variant!=interface_type)
			{ error3(505,thissymb->ident);
			  continue;
			}
		if (thissymb->entry.proc_decl.num_input!=2)
			error3(506,thissymb->ident);
		dummy=thissymb->entry.proc_decl.symb_list;
		while (dummy!=SMNULL)
		{
			if ((dummy->attr & OPTIONAL_BIT)!=0)
				error3(503,dummy->ident);
    			if  (((dummy->attr & OUT_BIT) !=0) && ((dummy->attr & INOUT_BIT)!=0))
				error3(507,dummy->ident);
			dummy=dummy->entry.var_decl.next_in;
   			if ((dummy->attr & OPTIONAL_BIT)!=0)
				error3(503,dummy->ident);
			if (((dummy->attr) & (IN_BIT))==0)
				error3(504,dummy->ident);
			dummy=dummy->entry.var_decl.next_in;
		}
	}
	return(0);
}

int interface_stmt()
{ 	PTR_BFND  thisbfnd=cur_bfnd,sub1_bfnd,sub2_bfnd;
	PTR_SYMB  thissymb,interface_name=cur_bfnd->entry.Template.symbol;
	int errcode=0;
	int kind; /* generic_name*/
    	int	interface_type=-1,interface_arg=-1; 
	PTR_SYMB	dummy,sub1_name,sub2_name,sym;
	char	*ident,err_string;
	PTR_BLOB	sub1_blob,sub2_blob;

						/* add by zheng.gb */
/* zheng.gb 4.30.1996 so that can access to the internal of interface body 0=> 1
	but when intrinsic.f is compiled , do not push evry scope so that
	the speed is so slow.
*/
	add_scope_level(cur_bfnd,0);

	if (thisbfnd->control_parent->variant==BLOCK_DATA)
		error1(508);
						/* modified by zheng.gb */
	if (interface_name && strcasecmp(interface_name->ident,NULL_UNIT_HEAD)!=0 ) 
	{
		/* interface_name->decl=0; */
		sym=search_symb_decl(interface_name); /* zheng.gb 1996.5.21 */
		/* interface_name->decl=1; */
						/* modified by zheng.gb */
		if (sym!=interface_name && sym->variant != INTERFACE_NAME &&
		sym->variant != FUNCTION_NAME && 
		sym->variant != PROCEDURE_NAME)
		error3(532,sym->ident);

		interface_name->decl=HARD;
	}
	in_interface_body ++ ; /* added by Feng Xiaobing */
	return(0);
}



check_interface()
{	PTR_SYMB	sym=fi->head_symb;
	
	for(;sym;sym=sym->thread)
	{	if (sym->variant==INTERFACE_NAME && strcasecmp(sym->ident,NULL_UNIT_HEAD) !=0 )  
		{
			check_each_inter(sym);
		}
	}
}

	
check_each_inter(sym)
PTR_SYMB 	sym;
{
	PTR_SYMB	thissymb=sym->entry.Template.next;
        int errcode=0;
         int kind; /* generic_name*/
          int     interface_type=-1,interface_arg=-1;
          PTR_SYMB        dummy,sub1_name,sub2_name;
          char    *ident,err_string;


	/*add kind to interface name in symbol table*/
	if ((sym->attr & DEFINED_OPERATOR_BIT)!=0)
		{
  		 /*OPERATOR*/
		errcode=inter_oper(sym,interface_type,interface_arg);
		   if (errcode!=0)
 			 return(errcode);
		}
		else {	if ((sym->attr & DEFINED_ASSIGNMENT_BIT)!=0)
			   {
				/*ASSIGNMENT*/
	    	 		errcode=inter_ass(sym,interface_type,interface_arg);
				if (errcode!=0)
					return(errcode);
				}
			else
				{
				interface_type=-1;
				interface_arg=-1;
				}
			}
		/* check whether two subprogram is distinguished*/
	for (sub1_name=sym->entry.Template.next;sub1_name;sub1_name=sub1_name->entry.Template.next)
	{  for (sub2_name=sub1_name->entry.Template.next;sub2_name;sub2_name=sub2_name->entry.Template.next)
	      {
		if (interface_type==-1)
		     	{ interface_type=sub1_name->variant;}
			else {	if (interface_type!=sub1_name->variant)
					error3(509,sub1_name->ident);
				}
	   	 if (distinguished_of_sub(sub1_name,sub2_name)==0)
			{ if (distinguished_of_sub(sub2_name,sub1_name)==0)
				{error4(510,sub1_name->ident,
				sub2_name->ident);
			  	return(errcode);
				}
			}
		}
 	 }
	return(0);
}

/*distinguish between two subroutine or function; 
	return 1: can distinguish; 0:can't
*/
int	distinguished_of_sub( sub1, sub2)
PTR_SYMB	sub1;
PTR_SYMB	sub2;
{	PTR_SYMB dummy1,dummy2;
	int	sequ=0;

	dummy1=sub1->entry.proc_decl.symb_list;
	while (dummy1!=SMNULL)
	{	if ((dummy1->attr & OPTIONAL_BIT) ==0)
		{ 	if ((dummy2=find_arg_position(sub2,sequ))==SMNULL)
				return(1);
		  	if (distinguished_of_arg(dummy1,dummy2))
				{return(1);}
			/*
			if ((dummy2=find_arg_keyword(sub2,dummy1->ident))==SMNULL)
				return(1);
			if (distinguished_of_arg(dummy1,dummy2))
				return(1);
			*/
		}
		dummy1=dummy1->entry.var_decl.next_in;
		sequ++;
	  
	}
	return(0);
}


/*distinguished  between two dummy argument
return 1: can; 0:can't
*/
int distinguished_of_arg( dummy1, dummy2)
PTR_SYMB	dummy1,dummy2;
{	
	int rank1=0,rank2=0;
	PTR_TYPE  tp1,tp2;

	tp1 = get_base_type(dummy1->type);
	tp2 = get_base_type(dummy2->type);

	if (tp1!=tp2)  return(1);

	if (dummy1->type->variant==T_ARRAY)
			rank1=dummy1->type->entry.ar_decl.num_dimensions;
	if (dummy2->type->variant==T_ARRAY)
			rank2=dummy2->type->entry.ar_decl.num_dimensions;
	if (rank1!=rank2)  return(1);

	if      ((dummy1->attr & POINTER_BIT) !=  (dummy2->attr & POINTER_BIT))
		return(1);
	return(0);
}


/*return SMNULL: can't find corresponding argument,so can distell
*/
PTR_SYMB	find_arg_position( sub, seq)
PTR_SYMB	sub;
int	seq;
{	int i;
	PTR_SYMB	dummy=sub->entry.proc_decl.symb_list;

	for(i=seq;(i>0) && (dummy!=SMNULL);i--)
		dummy=dummy->entry.var_decl.next_in;
	return(dummy);
}


PTR_SYMB 	find_arg_keyword( sub,id )
PTR_SYMB	sub;
char	*id;
{	PTR_SYMB	dummy2;
	
	for(dummy2=sub->entry.proc_decl.symb_list;dummy2 ;dummy2=dummy2->entry.var_decl.next_in)
	{	
		if (strcasecmp(dummy2->ident,id)==0)
		      return (dummy2);
	}
	return(dummy2);
}


int	module_proc_stmt()
{	PTR_BFND 	parent=cur_bfnd->control_parent,thisbfnd=cur_bfnd,bfnd;
	PTR_LLND	proc_list=thisbfnd->entry.var_list_decl.list;
	PTR_SYMB	proc_name,sym;

	if(parent->variant!=INTERFACE_STMT)
		error1(511);
	if	(parent->entry.Template.symbol==SMNULL)
		error3(512,proc_name->ident);
	for(;proc_list;proc_list=proc_list->entry.list_s.next)
	{	
		proc_name=proc_list->entry.list_s.item->entry.Template.symbol;
		sym=search_symb_ref(proc_name);
		if (sym!=proc_name)
		{
		  proc_name->scope = BFNULL;    /* no use */
		  proc_list->entry.list_s.item->entry.Template.symbol = sym;
		  proc_name = sym ;     /* zheng.gb 1996.5.8 */
		}
		if ((proc_name->variant!=FUNCTION_NAME) && (proc_name->variant !=PROCEDURE_NAME))
			error3(513,proc_name->ident);
		if (proc_name->scope->variant!=MODULE_STMT)
			error3(514,proc_name->ident);
		if ((proc_name->attr & PRIVATE_BIT)!=0 &&
			!in_same_module(proc_name) )
			error3(538,proc_name->ident);
			/* link to  declared name of interface */
		/*proc_name->attr=proc_name->attr | INTERFACE_BIT;*/
                       /*      add by zheng.gb */
                if (parent->entry.Template.symbol) {
                           for (sym=parent->entry.Template.symbol;
                                sym->entry.Template.next;
                                sym=sym->entry.Template.next);
                           sym->entry.Template.next=proc_name;
                }
	}
	/* the following statements added by Feng Xiaobing */
	proc_name->entry.proc_decl.common_table = CNTNULL;
	common_sequence_flag = 0;
	in_subprogram = 1;

}
	

int	external_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd,parent=thisbfnd->control_parent;
	PTR_SYMB	external_name,sym;
	PTR_LLND	external_list=thisbfnd->entry.var_list_decl.list;

/* the following statement is added by Feng Xiaobing */
	if (in_block_data) {
		error1(461);
		return (1);
	}
	for(;external_list;external_list=external_list->entry.list_s.next)
		{	external_name=external_list->entry.list_s.item->entry.Template.symbol;
			external_name->decl=0;
         		sym=search_symb_ref(external_name);
			external_name->decl=1;
			if (sym!=SMNULL)
				{ if ((sym->variant==FUNCTION_NAME) || (sym->variant==PROCEDURE_NAME))			  
					     external_name->entry.Template.declared_name=sym;
				  if ((sym->variant==VARIABLE_NAME) && (sym->scope==external_name->scope))
				  	{ sym->attr=sym->attr | EXTERNAL_BIT;
					  external_name->scope=BFNULL;
					  external_name=sym;
					external_list->entry.list_s.item->entry.Template.symbol=sym;
					}
				}
				else {sym=external_name;}
         		if ((sym!=external_name) && (sym->scope==external_name->scope) && ((sym->attr & INTRINSIC_BIT) || (sym->attr & EXTERNAL_BIT)))
				error3(531,sym->ident);
			if (sym!=SMNULL)
				if ((sym->attr & ENTRY_BIT)!=0)
					 error3(517,external_name->ident);
			if ((external_name->attr & INTRINSIC_BIT)!=0)
				error3(516,external_name->ident);
			if(external_name->type!=TYNULL)
				external_name->variant=FUNCTION_NAME;
			sym=parent->entry.Template.symbol;
			if (sym!=SMNULL)
				if ((sym->attr & PURE_BIT)  && (external_name->entry.var_decl.local==IO))
					error3(534,external_name->ident);
		}
	return(0);
}
	

int	intrinsic_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd;
	PTR_LLND	intrs_list=cur_bfnd->entry.var_list_decl.list;
	PTR_SYMB	intrs_name,sym;

/* the following statement is added by Feng Xiaobing */
	if (in_block_data) {
		error1(462);
		return 1;
	}

	for  (intrs_list=cur_bfnd->entry.var_list_decl.list;intrs_list!=LLNULL;intrs_list=intrs_list->entry.list_s.next)
		{	intrs_name=intrs_list->entry.list_s.item->entry.Template.symbol;
			intrs_name->decl=0;
                        sym=search_symb_ref(intrs_name);
			intrs_name->decl=HARD;
			if (sym!=SMNULL)
				{ if ((sym->variant==FUNCTION_NAME) || (sym->variant==PROCEDURE_NAME))
				 	intrs_name->entry.Template.declared_name=sym;
                                  if ((sym->variant==VARIABLE_NAME) && (sym->scope==intrs_name->scope))
                                        { sym->attr=sym->attr | INTRINSIC_BIT;
                                          intrs_name->scope=BFNULL;
                                          intrs_name=sym;
					intrs_list->entry.list_s.item->entry.Template.symbol=sym;
                                        }       

				}
				else { sym=intrs_name;}
                        if ((sym!=intrs_name)  &&  (sym->scope==intrs_name->scope) && ((sym->attr & EXTERNAL_BIT) || (sym->attr & INTRINSIC_BIT)))
                                error3(531,sym->ident);

			if ((intrs_name->attr  & EXTERNAL_BIT)!=0)
				error3(516,intrs_name->ident);
                        if (sym!=SMNULL)
                                if ((sym->attr & ENTRY_BIT)!=0)
                                         error3(517,sym->ident);
  
		}
	return(0);
}

int	function_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd;
	int	errcode,def;
	PTR_LLND	exp,prefix;
	PTR_SYMB	result=SMNULL,func_name=thisbfnd->entry.func_stmt.func_symb;
	PTR_TYPE        func_type;
	long int	attr=func_name->attr;;

	/* remove dummy attribute */
	remove_dummy_attr(thisbfnd);

	equi_ring_number = 0;		/* added by Feng Xiaobing for EQUIVALENCE statement */
	if ((errcode=sub_hedr_check(thisbfnd))!=0)
		return(errcode);
	exp=thisbfnd->entry.func_stmt.ftype;
	if (exp!=LLNULL)
		result=exp->entry.var_ref.symbol;
	if (result!=SMNULL)  
		{   
/* by zheng.gb 1996.6.28 
		    func_name->entry.Template.declared_name=result;
*/
		    result->decl = HARD;
		    if	(strcasecmp(result->ident,func_name->ident)==0) 
				error4(519,func_name->ident,result->ident);
		    def=0;
                    prefix=thisbfnd->entry.Template.ll_ptr2;
                    for(;prefix!=LLNULL;prefix=prefix->entry.list_s.next)
                    {       
			if (prefix->entry.list_s.item->variant==TYPE_OP)
			{
				def=1;
				func_type=prefix->entry.list_s.item->type;
				break;
			}
                    }
		    if (def == 0) 
			if (var_declared(func_name)==1) {
				func_type=func_name->type;
				def=1;
			}

				/* func_name not declared type */
		    if (def == 0)
		    {
                    	func_name->type=result->type;
		    }
                                    /* func_name decl  */
		    else if (var_declared(result) == 1)
			 {
                           if( func_type !=result->type)
				error4(520,func_name->ident,result->ident);
			 }
			 else         /* func_name decl , result not decl */
				result->type=func_name->type;
				
		}
	/* the following statements added by Feng Xiaobing */
	func_name->entry.func_decl.common_table = CNTNULL;
	common_sequence_flag = 0;
	in_subprogram = 1;

	thisbfnd->entry.func_stmt.func_symb->decl = HARD;

	return(0);
}



int	sub_hedr_check( thisbfnd)
PTR_BFND	thisbfnd;
{	PTR_SYMB 	sub_name = thisbfnd->entry.Template.symbol;
	PTR_SYMB        sym,s;
	PTR_BFND	parent=thisbfnd->control_parent,scope;
	PTR_LLND	prefix;
	PTR_SYMB	interface_name,dummy;
	PTR_TYPE        base_type;
	PTR_LLND	typeop;
	int	attr;
	int  		errcode;
	
	if (checking_part!=3) scope_status = NON_PURE;	/* add by zheng.gb */

/*	add by zheng.gb */
/*
	if ( ! in_interface_body) {
		sub_name->decl=0;
		top_scope_level--; 
		sym=search_symb_ref(sub_name);
		top_scope_level++; 
	}
	else {
		scope = cur_scope();
		sym=look_up_symb_at_scope_in_hash(sub_name->ident,scope->control_parent);
		if (sym == SMNULL)
			sym = sub_name;
	}
*/
		/* search current scope to see if duplicate 1996.5.15 */
	sym = search_symb_decl(sub_name);
	if (debug1) printf("Search routine:%s searched:%s.\n",thisbfnd->entry.Template.symbol->ident, sym->ident);
/*
	if (sym !=sub_name)
		error3(133,sub_name->ident);
*/
	
	/* check result name */
	if (BIF_LL1(thisbfnd))
	{
	   PTR_SYMB result = NODE_SYMB(BIF_LL1(thisbfnd));
 	   if (strcasecmp(result->ident, sub_name->ident) == 0)
		error3(133,sub_name->ident);
	}

		/* search if it is for a dummy description */
	if (in_interface_body)
	{                /* parent => interface , parent->control_parent */
		sym=look_up_symb_at_scope_in_hash(sub_name->ident,parent->control_parent);
		if (sym && sym->variant == VARIABLE_NAME && sym->decl == HARD )
			if (sym->entry.var_decl.local == IO) {
				/* zheng.gb 5.10 */
				sym->entry.Template.declared_name = sub_name;
			}
	}
/*
	if (sym!=sub_name) 
	  if (sym->variant !=INTERFACE_NAME  && sym->variant!= COMMON_NAME )
	  {
		if (sym->variant == FUNCTION_NAME ||
		    sym->variant == PROCEDURE_NAME )
		{
			if (sym->decl==1 && sym->scope == sub_name->scope)
				error3(133,sub_name->ident);
		}
		else  if (sym->variant == VARIABLE_NAME && sym->decl == HARD )
			if (sym->entry.var_decl.local == IO) {
				sym->entry.Template.declared_name = sub_name;
			}
			else
			  error3(133,sub_name->ident);
	  }
*/
	sub_name->decl=HARD;

	if (parent->variant==INTERFACE_STMT)
		{	
			sub_name->attr=sub_name->attr | INTERFACE_BIT;
						/*	add by zheng.gb */
			if (parent->entry.Template.symbol) {
			   for (sym=parent->entry.Template.symbol;
				sym->entry.Template.next;
				sym=sym->entry.Template.next);
			   sym->entry.Template.next=sub_name;
			}
		}
	prefix=BIF_LL2(thisbfnd);
	attr=sub_name->attr;
	for(;prefix!=LLNULL;prefix=prefix->entry.list_s.next)
	{	switch (prefix->entry.list_s.item->variant )
		{	case PREFIX_PURE:	attr=attr | PURE_BIT;
						/* add by zheng.gb */
				/*	if (checking_part!=3) */
					  scope_status= sub_name->
						variant ==FUNCTION_NAME
						 ? PURE_FUNC: PURE_PROC;
								break;
			case PREFIX_RECURSIVE:	attr=attr | RECURSIVE_BIT;
								break;
			case PREFIX_EXTRINSIC:  
				switch ( NODE_OPERAND0(prefix->entry.list_s.item)->variant )
				{
					case PREFIX_HPF:	attr=attr | EXTRINSIC_HPF_BIT;
									break;
					case PREFIX_HPFLOCAL:	attr=attr | EXTRINSIC_HPFLOCAL_BIT;
									break;
				}
				break;             /* zheng.gb */
/*	modified by zheng.gb */
			case TYPE_OP:	
					/* by zheng.gb 1996.5.7 */
				typeop=prefix->entry.list_s.item;
				base_type=get_base_type(sub_name->type);
        			if (base_type->variant == DEFAULT)
        			{
                			sym=search_symb_ref(sub_name->type->name);
               				if (sym!=sub_name->type->name &&
                       			   sym->variant == TYPE_NAME ) 
					{
						sub_name->type=look_up_record(fi,sym);
						typeop->type=sub_name->type;
               				}
               				else error3(206,sub_name->type->name->ident);
        			}
				/* check if function type is redeclared */
				errcode=is_exact_same_basetype(sub_name->type,typeop);
				if (errcode) error3(260,sub_name->ident);
				break;
			default:	error1(518);
		}
	}
	sub_name->attr=attr;

	for(dummy=sub_name->entry.proc_decl.symb_list;dummy;
				dummy=dummy->entry.var_decl.next_in)
	{	
					/* if duplicate dummy add by zheng.gb */
		for (s = sub_name->entry.proc_decl.symb_list; s && s!=dummy ;
				s = s->entry.var_decl.next_in)
			if ( strcasecmp(s->ident,dummy->ident) == 0) {
				if (dummy->ident[0]!='*')
				{
					error3(232,dummy->ident);
					break;
				}
			}

		if ((sub_name->attr & PURE_BIT)!=0)
		{
				if ((dummy->attr & IN_BIT) ==0)
					error3(504,dummy->ident);
				if ((dummy->attr & EXTERNAL_BIT)!=0)
					error3(533,dummy->ident);
				if ((dummy->attr & POINTER_BIT)!=0)
					error3(521,dummy->ident);
			}

		dummy->decl = HARD;           /* add by zheng.gb 1996.5.10 */
	}			/* for */

	return(0);
}

int	subroutine_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd;
	int errcode;

	/* remove dummy attribute */
	remove_dummy_attr(thisbfnd);

	equi_ring_number = 0;			/* added by Feng Xiaobing for EQUIVALENCE statement */
	errcode=sub_hedr_check(thisbfnd);
	/* the following statements added by Feng Xiaobing */
	thisbfnd->entry.Template.symbol->entry.proc_decl.common_table = CNTNULL;
	thisbfnd->entry.Template.symbol->decl=HARD;
	common_sequence_flag = 0;
	in_subprogram = 1;

	return(errcode);
}


int	entry_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd,parent=cur_bfnd->control_parent;
	PTR_SYMB	result=SMNULL,entry_name,sub_name,dummy;
	PTR_LLND	p;
	int	errcode;

	entry_name=thisbfnd->entry.Template.symbol;
	sub_name=parent->entry.Template.symbol;
	if ((parent->variant!=FUNC_HEDR)&& (parent->variant!=PROC_HEDR))
		error1(522);
	if (p=thisbfnd->entry.entry.result)
		result=p->entry.var_ref_s.symbol;
	if (result!=SMNULL)
		{	sub_name->entry.Template.declared_name=result;
			parent=thisbfnd->control_parent;
			if (parent->variant==PROC_HEDR)
				error1(523);
		}
	entry_name->attr=sub_name->attr;
	/*the following hasn't be done by HIT*/
	if (parent->variant==FUNC_HEDR)
		{	dummy=entry_name->entry.proc_decl.symb_list;
			for (;dummy!=SMNULL;dummy=dummy->entry.var_decl.next_in)
				{	if (dummy->variant==KEYWORD_VAL)
						if (dummy->ident=="*")
							error1(524);
				}
				/* by zheng.gb if entry decleared no type */	
			if (entry_name->type==TYNULL)
				error3(599,entry_name->ident);
			else
			if (errcode=distinguished_of_arg(entry_name,sub_name))
				{ 	if (((entry_name->attr & POINTER_BIT)!=0) || ((sub_name->attr & POINTER_BIT)==1))			
						error4(525,entry_name->ident,sub_name->ident);
 					
					if ((entry_name->type->variant==T_ARRAY) || (sub_name->type->variant==T_ARRAY) || (entry_name->type->variant==T_RECORD) || (sub_name->type->variant==T_RECORD))
						error4(525,entry_name->ident,sub_name->ident);
				}
		}
	return(0);
}


int return_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd;
	PTR_BFND        scope=cur_scope();
	PTR_LLND	return_expr;
	int 	variant=scope->variant;

	if ((variant!=PROC_HEDR) && (variant!=FUNC_HEDR))
		error1(526);
	return_expr=thisbfnd->entry.return_stmt.expr;
	if ((return_expr!=LLNULL) && (variant==FUNC_HEDR))
		error1(527);
	return(0);
}


int	contains_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd,parent;
	int	variant;

	parent=thisbfnd->control_parent->control_parent;
	if (parent!=global_bfnd)
		 { error1(528);
		}
	return(0);
}


/* modify assignment to stmt_function_stmt
return  0:success; 535:failure
*/
int modify_ass_to_func(thisbfnd)
PTR_BFND	thisbfnd;
{	int errcode=535,num_in=0,id;	
	PTR_LLND	exp;
	PTR_SYMB	func_name,id_list=SMNULL,sym,dummy;

/*
	if (thisbfnd->variant!=ASSIGN_STAT)
		return(errcode);
*/
			/* f() = expr ;  have recognized in f90.y */
	if (thisbfnd->entry.Template.ll_ptr2 == LLNULL) return 0;
				/* exp =>  ARRAY_REF */
	exp=thisbfnd->entry.Template.ll_ptr1;
	if (exp->variant!=ARRAY_REF)
		return(errcode);
	if (exp==LLNULL)
		{ return(errcode);}
	func_name=exp->entry.Template.symbol;
	exp=exp->entry.Template.ll_ptr1;
	check_dummy_dup(exp);
	if (func_name==SMNULL) 
		return(errcode);
	for (;exp;exp=exp->entry.Template.ll_ptr2)
	{	sym=exp->entry.Template.ll_ptr1->entry.Template.symbol;
		if (sym==SMNULL)
			return(errcode);
		dummy=make_symb(fi,VARIABLE_NAME,sym->ident);
		dummy->type=sym->type;
		dummy->attr=sym->attr;
		dummy->entry=sym->entry;
		dummy->scope=thisbfnd;
		dummy->entry.var_decl.next_in=id_list;
                dummy->entry.var_decl.local=IO;
		id_list=dummy;
		num_in++;;
	}
	func_name->variant=FUNCTION_NAME;
	func_name->entry.func_decl.num_input=num_in;
	func_name->entry.func_decl.num_output=1;
	func_name->entry.func_decl.symb_list=id_list;
	func_name->entry.func_decl.func_hedr=thisbfnd;
	exp=thisbfnd->entry.Template.ll_ptr2;
	thisbfnd->entry.Template.symbol=func_name;
	thisbfnd->entry.Template.ll_ptr2=LLNULL;
      	add_scope_level(thisbfnd,0);
	check_expr_type(exp);
        delete_beyond_scope_level(0);
	if (!is_scalar(exp->type))
		return 536;
/*	if (exp->attr & DIMENSION_BIT)
		return(536); */
	thisbfnd->entry.Template.ll_ptr1=exp;
	thisbfnd->variant=STMTFN_STAT;
	return(0);
}



int	stmt_function_stmt()
{	PTR_BFND	thisbfnd=cur_bfnd;
	int	variant=thisbfnd->control_parent->variant;
	PTR_SYMB	dummy,sub_name;
	int	errcode;

       if ((variant!=PROC_HEDR) && (variant!=FUNC_HEDR) && (variant!=PROG_HEDR))
		error1(529);
	if (errcode=modify_ass_to_func(thisbfnd))
		{ error1(errcode);}
	sub_name=thisbfnd->entry.Template.symbol;
	if(sub_name->attr & DIMENSION_BIT)
		error3(530,sub_name->ident);
	dummy=sub_name->entry.proc_decl.symb_list;
	for(;dummy;dummy=dummy->entry.var_decl.next_in)
		{	if(dummy->attr & DIMENSION_BIT)
				error3(530,dummy->ident);
		}
	sub_name->decl=HARD;
	return(0);
}


/*	modified by zheng.gb */
int	call_or_func(fi,thisbfnd,sub_name,actual_list,type,kind,func_type)
PTR_FILE        fi;
PTR_BFND	thisbfnd;
PTR_SYMB	sub_name;
PTR_LLND	actual_list;
int		type;		/*FUNCTION_NAME: call subroutine;
				  PROCEDURE_NAME :call function 
				  -1: intrinsic func call
				  -2: intrinsic proc call */
int		kind;      	/* 0: not report error 1: yes */
PTR_TYPE   	*func_type;
{	PTR_SYMB	spec_name,parent_name;
	PTR_LLND	param,call_list,p,q;
	int	errcode=1,variant;
	PTR_SYMB        sym,tmp;
	PTR_BFND	scope=cur_scope();
	PTR_BLOB        blob;
	int             savetype=type;

	sym=search_symb_ref(sub_name);
						/* modified by zheng.gb */
	  /* intrinsic do not search */
	if (type >0 && sym!=sub_name){
		/*thisbfnd->entry.Template.ll_ptr1->entry.Template.symbol=sym;*/
		sub_name->scope = BFNULL;
		sub_name=sym;
	  }

	if (is_dummy(scope , sym) )
	{
		/* if the function is a dummy , I donnot know how to handle this ?? */
		cur_subname = sub_name ; 
		return 0;
	}

	  /* cannot find the func */
	if (type>0 && type!=sub_name->variant && 
		sub_name->variant!=INTERFACE_NAME)
	{
		  /* added by zheng.gb 1996.6.17 */
		cur_subname=sub_name; 
		if (kind==1)  insert_undef(sym);
		if (thisbfnd->checked==HARD && kind==1)
		{
			thisbfnd->checked=SOFT;		/* need checking afterwards */
			for( ;actual_list;
				actual_list=actual_list->entry.list_s.next)
			{
			 param=actual_list->entry.list_s.item;
			 if (param->variant == KEYWORD_ARG)
				param=param->entry.Template.ll_ptr1;
			 Check_expr_type(param);    /* 1997/1/4 */
			}
			if (type==FUNCTION_NAME)
				*func_type=global_default;
			return(0);
                 }
		/* if (kind)  error3(595,sym->ident); */
		return 595;
	}

	if (type >0) {
		if (scope_status != NON_PURE && (sub_name->attr & PURE_BIT) ==0)
                                error1(212);
	}
	if (type ==-1) {
		type = FUNCTION_NAME;
		sub_name->variant == FUNCTION_NAME;
	}
	if (type ==-2) {
		type = PROCEDURE_NAME;
		sub_name->variant == PROCEDURE_NAME;
	}
	
/* 				for test by zheng.gb 
	tmp=get_interface_one_by_one(sym,1);
	printf("first:%s\n",tmp->ident);
	while(tmp) {
		tmp=get_interface_one_by_one(sym,0);
		printf("Other:%s\n",tmp->ident);
	}
*/
	cur_subname = sub_name ; 
	variant=sub_name->variant;
	parent_name=scope->entry.Template.symbol;
	if (sub_name->entry.Template.func_hedr &&
		 sub_name->entry.Template.func_hedr->variant==ENTRY_STAT)
	{ 
		sym=sub_name->entry.Template.func_hedr->control_parent->entry.Template.symbol;
	}
	else {  
		sym=sub_name;
	}

	if (savetype > 0)             /* save intrinsic call will cause dumpdep
					core dump    zheng.gb 1996.5.8 */
	   if ((parent_name!=SMNULL) && ((parent_name->variant==FUNCTION_NAME) 
				|| (parent_name->variant==PROCEDURE_NAME)))
	   {	call_list=parent_name->entry.Template.call_list;
		p=makeLlnd(fi,VAR_REF,LLNULL,LLNULL,sym);
		q=makeLlnd(fi,EXPR_LIST,p,call_list,SMNULL);
		parent_name->entry.Template.call_list=q;
	   }
	if (sub_name->variant==ROUTINE_NAME)
		{ sub_name->variant=type; }
	 if ((sub_name->attr & EXTERNAL_BIT)!=0) 
		{ 	if (sub_name->variant!=FUNCTION_NAME) 
				{	
				if  (type==FUNCTION_NAME)
					{ if (kind)
						error3(539,sub_name->ident); 
					  return 539;  /* by zheng.gb */
					}
					/*	else {sub_name->variant=FUNCTION_NAME;} */
				}
		 	if (sub_name->variant!=PROCEDURE_NAME) 
				{ 	if (type==PROCEDURE_NAME)
					{ if (kind)
						error3(540,sub_name->ident);
					  return 540;	/* by zheng.gb */
					}
					/*	else {sub_name->variant=PROCEDURE_NAME;} */
				}
		}
	switch (sub_name->variant)
	{
		case	INTERFACE_NAME:
			spec_name=sub_name->entry.Template.next;
/* add by zheng.gb */
			for(;spec_name!=SMNULL;spec_name=spec_name->entry.Template.next)
			{
				/* add by zheng.gb 1886.7.3 */
/*				if (savetype>0 && thisbfnd->checked==HARD && */
/*					is_extern(scope,spec_name)) 		*/
/*				{		*/
/*if (log_flag)		*/
/*fprintf(log_fd,"bfnd Soft:%s in %s line:%d\n",spec_name->ident,sub_name->ident,cur_bfnd->g_line);		*/
/*					thisbfnd->checked=SOFT;		*/
/*				}		*/

				if (spec_name->variant!=type)
				   { if (type==FUNCTION_NAME)
					{ if (kind)
						error3(539,sub_name->ident); 
					  return 539;
					}
					else {
					   if (kind)error3(540,sub_name->ident);
					   return 540;
					}
				    }
				if (match_arg(thisbfnd,spec_name,actual_list,savetype<0?1:0,0)==0)
				{
					if (savetype>0 && thisbfnd->checked==HARD && is_extern(scope,spec_name)) 
					{
if (log_flag)
fprintf(log_fd,"bfnd Soft:%s in %s line:%d\n",spec_name->ident,sub_name->ident,cur_bfnd->g_line);
						thisbfnd->checked=SOFT;
					}
					/*		zheng.gb
					if (savetype<0) {
						cur_subname = spec_name;
					}
					*/
					cur_subname = spec_name;
					if (spec_name->variant==FUNCTION_NAME)
					        *func_type=spec_name->type;
					return(0);
				}
			}	/* for */
			errcode = savetype>0?541:598;
			if (kind) error3(errcode,sub_name->ident);
			return(errcode);
			break;
		case	FUNCTION_NAME:
		case	PROCEDURE_NAME:
				/* add by zheng.gb 1886.7.3 */
			if (is_extern(scope,sub_name)) {
				if (thisbfnd->checked == HARD) {
if (log_flag)
fprintf(log_fd,"bfnd => soft:%s line:%d\n",sub_name->ident,cur_bfnd->g_line);
					thisbfnd->checked=SOFT;
				}
				else {
					if (search_head_name(fi,sub_name->ident)==BFNULL)
						if (kind==1) insert_undef(sub_name);
						/*error3(702,sub_name->ident);*/
				}
			}
			if (sub_name->variant!=type)
                           { if (type==FUNCTION_NAME)
                         	    { if (kind) error3(539,sub_name->ident); 
					return 539;	/* by zheng.gb */
				    } 
                                  else {
					if (kind) error3(540,sub_name->ident);
					return 540;	/* by zheng.gb */
				  }
                           }

			if ((sub_name->attr & EXTERNAL_BIT)==0)
				{	if ((errcode=match_arg(thisbfnd,sub_name,actual_list,savetype<0?1:0,kind))!=0)
						return(errcode);
				}
			break;
	}	  /* switch */
	if (((variant==FUNCTION_NAME) || (variant==PROCEDURE_NAME)) && ((sub_name->attr &  INTERFACE_BIT)==0))

		{	if (actual_list!=LLNULL)
				param=actual_list->entry.list_s.item; 
			else {
						/* add by zheng.gb */
				if (sub_name->variant==FUNCTION_NAME)
					*func_type=sub_name->type;
				return(0); 
			}
			for(;actual_list!=LLNULL;actual_list=actual_list->entry.list_s.next)
			{	param=actual_list->entry.list_s.item;
				if ((param->variant==KEYWORD_ARG) && (param->entry.keyword.keyword!=LLNULL))
				{
					if (kind) error3(542,sub_name->ident);
					return 542;	/* by zheng.gb */
				}
			}
		}
	if (sub_name->variant==FUNCTION_NAME)		/* by zheng.gb */
		*func_type=sub_name->type;
	return(0);
}

int	match_arg(thisbfnd,sub_name,actual_list,is_intr,kind)
PTR_BFND	thisbfnd;
PTR_SYMB	sub_name;
PTR_LLND	actual_list;
int             is_intr;            /* 1: if is intrinsic call */
int	kind; /*0: called from interface, neednot print error; 
		1: called from subprogram,need print error
	      */	
{	int	errcode=0,keyword=0,sequ=1,err=0;
	PTR_SYMB	dummy_list=sub_name->entry.proc_decl.symb_list,dummy_arg=dummy_list,dum;
	PTR_LLND	actual_arg;
		
	for(;dummy_arg!=SMNULL;dummy_arg=dummy_arg->entry.var_decl.next_in)
	{	dummy_arg->entry.var_decl.associated=0;
	}
	dummy_arg=dummy_list;
	while ((actual_list!=LLNULL) && (dummy_arg!=SMNULL))
	{	
		actual_arg=actual_list->entry.list_s.item;
		actual_list=actual_list->entry.list_s.next;
		if (keyword==1)
		{	if (actual_arg->variant!=KEYWORD_ARG)
			  {	if (kind==1)
					error2(546,sequ);
				errcode=546;
				break;
			  }
		}
		if (keyword==0)
		{	if (actual_arg->variant==KEYWORD_ARG)
				keyword=1;
		}
		switch (keyword)
		{	
		case	0:
			errcode=compare_actual_dummy(thisbfnd,actual_arg,dummy_arg,sequ,is_intr,kind);
			dummy_arg=dummy_arg->entry.var_decl.next_in;
			break;
		case	1:
			dummy_arg=find_arg_keyword(sub_name,actual_arg->entry.keyword.keyword->entry.string_val);
			actual_arg=actual_arg->entry.Template.ll_ptr1;
			if (dummy_arg==SMNULL)
			{  
			   if (kind == 1) error2(569,sequ); 
			   errcode = 569;
			}
			else
			{
			   errcode=compare_actual_dummy(thisbfnd,actual_arg,dummy_arg,sequ,is_intr,kind);
			}
			break;
		}
/*	add by zheng.gb    */
	if (errcode !=0) {
		err=1;
		if (kind==0) break;                /* if called by interface, 
							break to save time */
	}
	sequ++;
	}	
	if (actual_list !=LLNULL)
		{ if (kind==1)
			error5(543,sequ,sub_name->ident);
		  errcode=543;
		}
	for(;dummy_list!=SMNULL;dummy_list=dummy_list->entry.var_decl.next_in)
		if (((dummy_list->attr & OPTIONAL_BIT)==0) && (dummy_list->entry.var_decl.associated==0))
		{	
			errcode=is_intr? 597:544;
			if (kind==1) 
		 	      error4(errcode,dummy_list->ident,sub_name->ident);
		}
	return(errcode);         /* zheng.gb 1996.5.14 */
}


int	compare_actual_dummy(thisbfnd,actual,dummy,sequ,is_intr,kind)
PTR_BFND	thisbfnd;
PTR_SYMB	dummy;
PTR_LLND	actual;
int	sequ;
int             is_intr;           /* 1: if is intrinsic call */
int	kind; /*0:don't print error; 1:print error*/
{	PTR_SYMB	actu_name,sym,dum=dummy;
	PTR_TYPE	actual_type,dummy_type;
	int			attr,errcode;
	
		/* if dummy is specified in interface body */
	if (dummy->variant == VARIABLE_NAME )
		if (dummy->entry.Template.declared_name)
			dum=dummy->entry.Template.declared_name;

	if (dummy->entry.var_decl.associated==1)
		{  if (kind==1)
			error3(545,dummy->ident);
		 return (545);}	
		else { dummy->entry.var_decl.associated=1;}
	if ((dummy->attr & EXTERNAL_BIT) ==1)
	{	if (actual->variant==VAR_REF)	
			{	actu_name=actual->entry.Template.symbol;
				attr=actu_name->attr;
				if ((attr & EXTERNAL_BIT) || (attr & INTRINSIC_BIT) || (attr & INTERFACE_BIT))
				  { if (kind==1)
				      {error3(548,actual->entry.Template.symbol->ident);}
				    return(548);
				  }

/*          compare dum  if it is specfied in interface zheng.gb 1996.5.10
				if ((dummy->variant==FUNCTION_NAME) && (actu_name->variant==PROCEDURE_NAME))
*/
				if ((dum->variant==FUNCTION_NAME) && (actu_name->variant==PROCEDURE_NAME))
				  {  if (kind==1)
					error3(547,actual->entry.Template.symbol->ident);
				     return(547);
				  }

/*                 zheng.gb 1996.5.10 
					if ((dummy->variant==PROCEDURE_NAME) && (actu_name->variant==FUNCTION_NAME))
*/
				if ((dum->variant==PROCEDURE_NAME) && (actu_name->variant==FUNCTION_NAME))
				  { if (kind==1)
					error3(549,actual->entry.Template.symbol->ident);
				    return(549);
				  }
				return(0);
			}
			else { if (kind==1)
				  error2(550,sequ);
				return(550);
			     }
	}     /*  if (external) */

		/* by zheng.gb  1996.5.10  */
	if (dum->variant == FUNCTION_NAME || dum->variant== PROCEDURE_NAME)
	{
	   if (actual->variant == VAR_REF)
	   {
		actu_name=actual->entry.Template.symbol;
		sym=search_symb_ref(actu_name);
		if (sym != actu_name)
			actu_name=sym;

		if (actu_name->variant != dum->variant)
		{
			if (dum->variant == FUNCTION_NAME)
			{
				if (kind==1)
					error3(547,actu_name->ident);
				return 547;
			}
			else  {
				if (kind==1)
                                        error3(549,actu_name->ident);
                                return 549;
                        }
		}
		else 
			return 0;
	   }         /* if var_ref */
	   else  {
		if (kind==1)
			error2(550,sequ);
		return 550;
	   }
	}

	if (strcmp(dummy->ident,"*")==0)
		{	if (actual->variant!=LABEL_REF)
			   {	if (kind==1)
				   error2(551,sequ);
				return(551);
			   }
			actual->entry.label_list.lab_ptr->labused=1;
			 if (check_goto_stmt(thisbfnd,actual->entry.label_list.lab_ptr->statbody)!=0)
			  {	if (kind==1)
					error1(552);
				return(552);
			  }
			return(0);
		}
	if ((actual->variant==LABEL_REF) && (strcmp(dummy->ident,"*")!=0))
	  {	if (kind==1)
                    error2(596,sequ);
                return(551);

 	  }

	/* if (thisbfnd->checked==HARD)   modified by zheng.gb 1997/1/2  ??? */
	Check_expr_type(actual);

	if ( actual->variant == VAR_REF || actual->variant == ARRAY_REF )
		actu_name=get_var_name(actual);
	else
		actu_name=SMNULL;
	if ( actual->type == TYNULL) {
		return 0;
	}
		
	if ((errcode=compare_dummy_type(actu_name,actual->type,dummy,sequ,is_intr,kind))!=0)
	{
		return(errcode);
	}

	if (is_assumed_shape_spec(dummy)==1) 
	    if  (!is_variable_llnd(actual))   /* zheng.gb 1996.5.24 */
		if (kind==1) error2(574,sequ);
		else    return(574);
	    else {
		     actu_name=get_var_name(actual);
		     if (is_assumed_size_spec(actu_name))
	   		{	if (kind==1)
					error2(553,sequ);
				return(553);
	   		}
		 }
	if ((ispoint_symb(dummy)==1) && (ispoint_llnd(actual)==0))
	   {	if (kind==1)
			error2(554,sequ);
		return(554);
	   }

	if (((dummy->attr & OUT_BIT)!=0) || ((dummy->attr & INOUT_BIT)!=0))	
	{	
		if (is_variable_llnd(actual))  /* zheng.gb 1996.5.24 */
		{	
			actu_name=get_var_name(actual);
			if (actu_name->entry.var_decl.local==IO)
			{
				attr=actu_name->attr ;
				if ((attr & IN_BIT)!=0)
				  {  
				     /* if (kind==1) */
					error2(555,sequ);
				     return(555);
				  }
			}
		}
		else {  /* if (kind==1) */
			   error2(550,sequ);
			  return(550);
		     }
		if (isindex_vector(actual)==1)
                {  
			/* if (kind==1) */
                        error2(555,sequ);
                       	return(555);
                }

	}
/* deleted by Yanmi
	if ((dummy->attr & IN_BIT)!=0) 
		{	if ((actual->variant==VAR_REF) || (actual->variant==ARRAY_REF))
			{	actu_name=actual->entry.Template.symbol;
				if (actu_name->entry.var_decl.local==IO)
				{
					attr=actu_name->attr;
					if ((( attr & IN_BIT)==0) && ((attr & INOUT_BIT)==0))
                            		{  
					   if (kind==1)
                                       		error2(555,sequ);
                                	   return(555);
                             		}


				}
			}
		}
*/
	return(0);
}



/* return 0: symbol is not POINTER; 1: yes */
int	ispoint_symb(symb)
PTR_SYMB	symb;
{	if ((symb->attr & POINTER_BIT)==0)
	     { return(0);}
		else {return(1);}
}

/*return 0: result of expression is not POINTER; 1:YES*/
int	ispoint_llnd(expr)
PTR_LLND	expr;
{	if ((expr->attr & POINTER_BIT)==0)
	   { return(1); }
	 else { return(1);}
}

/* return 0: index of result of expression is not av vector;
1: yes
*/
isindex_vector(expr)
PTR_LLND 	expr;
{
	if (expr->attr & DIMENSION_BIT)
		return(0);
	return(0);
}

/*compare actual and dummy array :shape
return 0: same;
*/
int compare_array_type(actual_type,dummy_type,sequ,kind)
PTR_TYPE  actual_type,dummy_type;
int	sequ,kind;
{	int errcode=0;
	
	
	return(errcode);
}

/* check argument passing and sequce association 
   return:  0: ok , 1: error */
int sequence_association_rule(actu_name,actual_type,dummy)
PTR_SYMB        actu_name;
PTR_TYPE        actual_type;
PTR_SYMB        dummy;
{
	/* Rule 1. actual argument as array element or name of assumed_size array */
	if ( (actu_name && actu_name->type && actu_name->type->variant == T_ARRAY  &&
		actual_type->variant != T_ARRAY) ||
		(actu_name && is_assumed_size_spec(actu_name)) )
	{
		if (is_scalar(dummy->type) ||  ( !is_scalar(dummy->type) && (dummy->attr & SEQUENCE_BIT) ) )
			return 0;
		return 1;
	}
	return 0;
}

int compare_dummy_type(actu_name,actual_type,dummy,sequ,is_intr,kind)
PTR_SYMB        actu_name;
int     sequ,kind,is_intr;
PTR_TYPE        actual_type;
PTR_SYMB        dummy;
{
        int err_code=0;
	PTR_TYPE  basetype;
	int  sequence ;

/*
	if (actu_name && (actu_name->attr & SEQUENCE_BIT) && (dummy->attr & SEQUENCE_BIT) )
*/
	if ((dummy->attr & SEQUENCE_BIT) )
		sequence = 1;
	else
		sequence = 0;

	if (is_intr) 		/* in intrinsic function */
	{
	  if (is_any_type(dummy->type)) 
	  {
		if (is_scalar(dummy->type)) {
			if (!is_scalar(actual_type))
				err_code=556;
		}
		else {
			if (is_scalar(actual_type))
				err_code=556;
			else if (dummy->type->entry.ar_decl.num_dimensions !=
				actual_type->entry.ar_decl.num_dimensions)
				err_code=556;
		}
	  }
	  else if (is_number_type(dummy->type)) {
		if (!isNumberType(actual_type))
			err_code = 556;
		else {
		   if (is_scalar(dummy->type)) {
			if (!is_scalar(actual_type))
				err_code=556;
		   }
		   else {
			if (is_scalar(actual_type))
				err_code=556;
			else if (dummy->type->entry.ar_decl.num_dimensions !=
				actual_type->entry.ar_decl.num_dimensions)
				err_code=556;
		   }
		}
	  }
	  else if (is_all_type(dummy->type))
		err_code=0;
	  else
		err_code = is_same_basetype(dummy->type, actual_type , sequence);
	}
	  /* not intrinsic functions */
	else {
		err_code=sequence_association_rule(actu_name,actual_type,dummy);
		if (!err_code)
			err_code = is_same_basetype(dummy->type, actual_type , sequence);
		if (!err_code && sequence==0)
			if (actual_type->variant == T_ARRAY &&
			    dummy->type->variant == T_ARRAY &&
			    !same_arraytype_range(dummy->type, actual_type))
			      err_code = 556;
	}
	if (kind == 1 && err_code !=0) {
		error6(err_code,sequ,dummy->ident,cur_subname->ident);
	}
	return err_code==0 ? 0:1;
}

/* compare type between actual arguments an d dummy.
 9: type mismatched
  10:kind mismatched
   11:derived type name mismatched		
	12: derived type of actual_arg must be SEQUENCE
	13: derived type of dummy_arg must be SEQUENCE
	14: base type of array mismatched
	15:rank of array mismatched
	16:len parameter of character mismatched
	17:actual_arg need be an array
	18: shape of array mismatched

	22: type of component of derived type mismatched;
	23:	component of derived type of actual arguments  need be PRIVATE
    24: component of derived type of dummy arguments  need be PRIVATE

*/
int compare_dummy_type1(actual_type,dummy,sequ,kind)
int	sequ,kind;
PTR_TYPE	actual_type;
PTR_SYMB	dummy;
{	PTR_SYMB	act_name,dum_name;
	PTR_TYPE	dummy_type=dummy->type;
	int	errcode;

	if (kind==3)
		dummy_type=dummy->type->entry.ar_decl.base_type;
	switch (dummy_type->variant)
	{	case	T_INT:
		case    T_WORD:
		case	T_BYTE:		/* treate them as same */
					if (!isIntClassType(actual_type))
					   { if (kind==1)
						error5(556,sequ,dummy->ident);
					     return(556);
					   }
					return(0);
					break;
		case	T_FLOAT:
		case	T_BOOL:
		case	T_COMPLEX:
		case    T_DCOMPLEX:
		case	T_DOUBLE:
		case	T_CHAR:
		case	T_STRING:
					/*??*/
					if (actual_type!=dummy_type)
					   { if (kind==1)
						error5(556,sequ,dummy->ident);
					     return(556);
					   }
					/*
					if (actual_type->kind!=dummy_type->kind)
						return(10);
					if ((dummy_type->variant==T_CHAR) && (dummy->len!=actual_type->len))
						return(16);
					*/
					return(0);
					break;
		case	T_RECORD:
					if (actual_type==dummy_type)
						return(0);
					if (strcmp(actual_type->name->ident,dummy_type->name->ident)!=0)
					  {  
					if (kind==1)
						error5(557,sequ,dummy->ident);
					     return(557);
					  }
					if ((actual_type->name->attr & SEQUENCE_BIT)==0)
					  {  if (kind==1)
						error2(558,sequ);
					    return(558);
					  }
					if ((dummy_type->name->attr & SEQUENCE_BIT)==0)
					  {  if (kind==1)
						error3(559,dummy->ident);
					     return(559);
					  }
					if (actual_type->entry.re_decl.num_fields!=dummy_type->entry.re_decl.num_fields)
                                         {  

					    if (kind==1)
                                                error5(557,sequ,dummy->ident);
                                             return(557);
					  }
					act_name=actual_type->entry.re_decl.first;
					dum_name=dummy_type->entry.re_decl.first;
					 for(;act_name!=SMNULL;act_name=act_name->next_symb,dum_name=dum_name->next_symb)
					{	if (strcmp(act_name->ident,dum_name->ident)!=0)
						  {  if (kind==1)
							error6(560,sequ,act_name->ident,dum_name->ident);
						     return(560);
						  }
						if ((act_name->attr & PRIVATE_BIT)==0)
                                                {  if (kind==1)
                                                        error6(561,sequ,act_name->ident,dum_name->ident);
                                                     return(561);
                                                  }

						if ((dum_name->attr & PRIVATE_BIT)==0)
						  {  if (kind==1)
							error4(562,dummy->ident,dum_name->ident);
						     return(562);
						  }
						if (compare_dummy_type1(act_name->type,dum_name,sequ,0)!=0)
						  {  if (kind==1)
							error5(563,sequ,act_name->ident);
						     return(563);
						  }
						return(0);
					}
					break;
		case	T_ARRAY:
					if (actual_type->variant!=T_ARRAY)
					  {  if (kind==1)
						error2(564,sequ);
					     return(564);
					  }
					if (compare_dummy_type1(actual_type->entry.ar_decl.base_type,dummy,sequ,3))
					   {  if (kind==1)
						error5(565,sequ,dummy->ident);
					      return(565);
					   }
					if (actual_type->entry.ar_decl.num_dimensions!=dummy_type->entry.ar_decl.num_dimensions)
					  {  if (kind==1)
						error5(566,sequ,dummy->ident);
					     return(566);
					  }
					errcode=compare_array_type(actual_type,dummy_type,sequ,kind);
					return(errcode);

					break;
		default:	return(0);
	}
	return(0);
}







/* the module is recusive?
return 1: yes; 0: no
*/
int	isrecursive_modu()
{
	PTR_SYMB	m[MAXMODULE];
	int	num=0,i,yes,cont=1;
		PTR_SYMB	thissymb=fi->head_symb,use_modu;
		PTR_LLND	use_list;
			
		while (thissymb!=SMNULL)
		{	if(thissymb->variant==MODULE_NAME)
			{	m[num]=thissymb;
				m[num]->entry.Template.seen=1;
				if (num++>=MAXMODULE)
					{ error1(567);/*waring : too many module,*/
						break;
					}
			}
			thissymb=thissymb->thread;
		}	
		for(i=0;i<num;i++)
		{	thissymb=m[i];
			if (thissymb->entry.Template.use_list==LLNULL)
				m[i]->entry.Template.seen=0;
		}		
		while (cont==1)
		{	cont=0;
			for(i=0;i<num;i++)
			   if (m[i]->entry.Template.seen==1)
			{	
				yes=0;
				for(use_list=m[i]->entry.Template.use_list;use_list;use_list=use_list->entry.list_s.next)
				{	use_modu=use_list->entry.list_s.item->entry.Template.symbol;
					if (use_modu->entry.Template.seen==1)
					{	yes=1;
					}
				}
				if (yes==0)
				{	cont==1;
					m[i]->entry.Template.seen=yes;
				}
			}
		}
		yes=0;
		for (i=0;i<num;i++)
		{	if (m[i]->entry.Template.seen==1)
			{	yes=1;
				error3(568,m[i]->ident);/*fatal error,is recursive*/
			}
		}
		return(yes);
	}



	init_sub()
	{ 	PTR_SYMB	thissymb=fi->head_symb;
	int	num=0;

       while (thissymb!=SMNULL)
        {       if (((thissymb->variant==FUNCTION_NAME) || (thissymb->variant==
  PROCEDURE_NAME)) && (thissymb->entry.Template.func_hedr && thissymb->entry.Template.func_hedr->variant!=ENTRY_STAT))
                {      num++;
                       thissymb->entry.Template.seen=1;
			thissymb->entry.Template.call_list=LLNULL;
                        if (num++>=MAXSUB)
                                { error1(570);/*waring : too many module,*/
                                        break;
                                }

                }
                thissymb=thissymb->thread;
	}


}

/* the subprogram  is recusive?
return 1: yes; 0: no
*/
int	isrecursive_sub(fi)
PTR_FILE	fi;
{
	PTR_SYMB	m[MAXSUB];
	int	num=0,i,yes,cont=1;
	PTR_SYMB	thissymb=fi->global_bfnd->entry.Template.bl_ptr1->ref->entry.Template.symbol;
	PTR_SYMB	sub_name;
	PTR_BLOB	cur_blob,pre_blob;
	PTR_SYMB	cur_sub,pre_sub;
	PTR_LLND	call_list;
	int j=0,variant;
		
/*
	pre_blob=fi->global_bfnd->entry.Template.bl_ptr1;
	for (;pre_blob->next;pre_blob=pre_blob->next)
	{	variant=pre_blob->ref->variant;
		if ((variant!=PROC_HEDR) && (variant!=FUNC_HEDR))
				continue;
		for(cur_blob=pre_blob->next;cur_blob;cur_blob=cur_blob->next)
		{	if ((cur_blob->ref->variant!=PROC_HEDR) && 
				(cur_blob->ref->variant!=FUNC_HEDR))	
			     continue;
			
		}
	}
*/
	while (thissymb!=SMNULL)   
	{	
		if (((thissymb->variant==FUNCTION_NAME) || (thissymb->variant==PROCEDURE_NAME)) && (thissymb->entry.Template.func_hedr == BFNULL || thissymb->entry.Template.func_hedr->variant!=ENTRY_STAT))
		{	m[num]=thissymb;
			m[num]->entry.Template.seen=1;
			if (num++>=MAXSUB)
				{ error1(570);
				 	break;
				}
		}
		thissymb=thissymb->thread;
	}	
	for(i=0;i<num;i++)
	{	thissymb=m[i];
		if (thissymb->entry.Template.call_list==LLNULL)
			m[i]->entry.Template.seen=0;
	}		
	while (cont==1)
	{	cont=0;
		for(i=0;i<num;i++)
		   if (m[i]->entry.Template.seen==1)
		{	
			yes=0;
			for(call_list=m[i]->entry.Template.call_list;call_list;call_list=call_list->entry.list_s.next)
			{	sub_name=call_list->entry.list_s.item->entry.Template.symbol;
				if (sub_name->entry.Template.seen==1)
				{	yes=1;
				}
			}
			if (yes==0)
			{	cont=1;
				m[i]->entry.Template.seen=yes;
			}
		}
	}
	yes=0;
	for (i=0;i<num;i++)
	{	if ((m[i]->entry.Template.seen==1) && ((m[i]->attr & RECURSIVE_BIT)==0))
		{	yes=1;
			error3(571,m[i]->ident);
		}
	}
}

